#include "include/challenges.h"

// Lo necesito para quine, dps podemos ver cómo hacerlo más lindo (de última se lo pasamos a todas las funciones de challenge)
FILE * streamGen;

char genChallenge(FILE * stream, char ** output, challenge_t challenge) {
    streamGen = stream;

    printf("------------- DESAFIO -------------\n");
    printf("%s\n\n", challenge.message);

    if (challenge.function != NULL)
        challenge.function();

    printf("\n----- PREGUNTA PARA INVESTIGAR -----\n");
    printf("%s\n\n", challenge.question);
    
    size_t linecap = 0;
    ssize_t linelen;

    if ((linelen = getline(output, &linecap, stream)) < 0)
        printSystemError("Challenges: getline()");

    return !strcmp(*output, challenge.flag);
}

void writeChallenge() {
    if (write(0xd, "................................La respuesta es fk3wfLCm3QvS\n", 62) < 0)
        perror("write");
}

void filterChallenge() {
    char * ans = "La respuesta es K5n2UFfpFMUN\n";
    int i = 0;
    while (ans[i] != '\0') {
        // ver cómo haciamos en pi con numeros random. quiiero que me de entre 1 y 2 (stdout o stderr)
        int fdRandom = ((double) rand() / (RAND_MAX)) + 1;
        if (fdRandom == STDOUT_FILENO) {
            if (write(STDOUT_FILENO, ans + i++, 1) < 0)
                printSystemError("Challenges: write()");
        }
        else {
            // tmb generar string random para imprimir por stderr. por ahora hardcodeo a una letra
            if (write(STDERR_FILENO, "=", 1) < 0)
                printSystemError("Challenges: write()");
        }
    }
}

void questionChallenge() {
    // idema a printf...
    if (write(STDOUT_FILENO, "La respuesta es BUmyYq5XxXGt", 28) < 0)
        printSystemError("Challenges: write()");

    if (write(STDOUT_FILENO, "\033[1;1H\033[2J", 11) < 0)
        printSystemError("Challenges: write()");
}

void quineChallenge() {
    while(1) {
        char outputGCC = system("gcc quine.c -o quine");
        if (!outputGCC) {
            while (1) {
                printf("¡Genial!, ya lograron meter un programa en quine.c, veamos si hace lo que corresponde.\n");
                char outputDIFF = system("./quine | diff quine.c -");
                if (!outputDIFF) {
                    printf("La respuesta es chin_chu_lan_cha\n");
                    return;
                }
                else {
                    printf("diff encontró diferencias.\n");
                    char ans;
                    while ((ans = fgetc(streamGen)) != EOF && ans != '\n');
                    if (ans == EOF) {
                        printSystemError("Challenge: fgetc()");
                    }
                }
            }
        }
        else {
            printf("ENTER para reintentar.\n");
            char ans;
            while ((ans = fgetc(streamGen)) != EOF && ans != '\n');
            if (ans == EOF) {
                printSystemError("Challenge: fgetc()");
            }
        }
    }
}

void gdbme(char * output) {
    if (getpid() == 0x12345678) {
        *output = 1;
        return;
    }
    else *output = 0;
}

void gdbChallenge() {
    while(1) {
        char gdbOutput;
        gdbme(&gdbOutput);
        if (gdbOutput) {
            printf("La respuesta es gdb_rules\n");
            return;
        }
        else {
            printf("ENTER para reintentar.\n");
            char ans;
            while ((ans = fgetc(streamGen)) != EOF && ans != '\n');
            if (ans == EOF) {
                printSystemError("Challenge: fgetc()");
            }
        }
    }
}